using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CallCenterApi.BLL
{
    /// <summary>
	/// 操作记录表
	/// </summary>
	public partial class T_Repository_Operation
    {
        private readonly CallCenterApi.DAL.T_Repository_Operation dal = new CallCenterApi.DAL.T_Repository_Operation();
        public T_Repository_Operation()
        { }
        #region  Method
        /// <summary>
        /// 是否存在该记录
        /// </summary>
        public bool Exists(int F_Id)
        {
            return dal.Exists(F_Id);
        }

        /// <summary>
        /// 增加一条数据
        /// </summary>
        public int Add(CallCenterApi.Model.T_Repository_Operation model)
        {
            return dal.Add(model);
        }

        /// <summary>
        /// 更新一条数据
        /// </summary>
        public bool Update(CallCenterApi.Model.T_Repository_Operation model)
        {
            return dal.Update(model);
        }

        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool Delete(int F_Id)
        {

            return dal.Delete(F_Id);
        }
        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool DeleteList(string F_Idlist)
        {
            return dal.DeleteList(F_Idlist);
        }

        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public CallCenterApi.Model.T_Repository_Operation GetModel(int F_Id)
        {

            return dal.GetModel(F_Id);
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetList(string strWhere)
        {
            return dal.GetList(strWhere);
        }
        /// <summary>
        /// 获得前几行数据
        /// </summary>
        public DataSet GetList(int Top, string strWhere, string filedOrder)
        {
            return dal.GetList(Top, strWhere, filedOrder);
        }
        /// <summary>
        /// 获得数据列表
        /// </summary>
        public List<CallCenterApi.Model.T_Repository_Operation> GetModelList(string strWhere)
        {
            DataSet ds = dal.GetList(strWhere);
            return DataTableToList(ds.Tables[0]);
        }
        /// <summary>
        /// 获得数据列表
        /// </summary>
        public List<CallCenterApi.Model.T_Repository_Operation> DataTableToList(DataTable dt)
        {
            List<CallCenterApi.Model.T_Repository_Operation> modelList = new List<CallCenterApi.Model.T_Repository_Operation>();
            int rowsCount = dt.Rows.Count;
            if (rowsCount > 0)
            {
                CallCenterApi.Model.T_Repository_Operation model;
                for (int n = 0; n < rowsCount; n++)
                {
                    model = new CallCenterApi.Model.T_Repository_Operation();
                    if (dt.Rows[n]["F_Id"] != null && dt.Rows[n]["F_Id"].ToString() != "")
                    {
                        model.F_Id = int.Parse(dt.Rows[n]["F_Id"].ToString());
                    }
                    if (dt.Rows[n]["F_RepositoryId"] != null && dt.Rows[n]["F_RepositoryId"].ToString() != "")
                    {
                        model.F_RepositoryId = int.Parse(dt.Rows[n]["F_RepositoryId"].ToString());
                    }
                    if (dt.Rows[n]["F_AuditId"] != null && dt.Rows[n]["F_AuditId"].ToString() != "")
                    {
                        model.F_AuditId = int.Parse(dt.Rows[n]["F_AuditId"].ToString());
                    }
                    if (dt.Rows[n]["F_LogId"] != null && dt.Rows[n]["F_LogId"].ToString() != "")
                    {
                        model.F_LogId = int.Parse(dt.Rows[n]["F_LogId"].ToString());
                    }
                    if (dt.Rows[n]["F_OptType"] != null && dt.Rows[n]["F_OptType"].ToString() != "")
                    {
                        model.F_OptType = int.Parse(dt.Rows[n]["F_OptType"].ToString());
                    }
                    if (dt.Rows[n]["F_OptContent"] != null)
                    {
                        model.F_OptContent = dt.Rows[n]["F_OptContent"].ToString();
                    }
                    if (dt.Rows[n]["F_State"] != null && dt.Rows[n]["F_State"].ToString() != "")
                    {
                        model.F_State = int.Parse(dt.Rows[n]["F_State"].ToString());
                    }
                    if (dt.Rows[n]["F_OptBy"] != null)
                    {
                        model.F_OptBy = dt.Rows[n]["F_OptBy"].ToString();
                    }
                    if (dt.Rows[n]["F_OptOn"] != null && dt.Rows[n]["F_OptOn"].ToString() != "")
                    {
                        model.F_OptOn = DateTime.Parse(dt.Rows[n]["F_OptOn"].ToString());
                    }
                    if (dt.Rows[n]["F_Reason"] != null)
                    {
                        model.F_Reason = dt.Rows[n]["F_Reason"].ToString();
                    }
                    
                    modelList.Add(model);
                }
            }
            return modelList;
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetAllList()
        {
            return GetList("");
        }

        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public int GetRecordCount(string strWhere)
        {
            return dal.GetRecordCount(strWhere);
        }
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetListByPage(string strWhere, string orderby, int startIndex, int endIndex)
        {
            return dal.GetListByPage(strWhere, orderby, startIndex, endIndex);
        }

        #endregion  Method
    }
}
